/*
 * File         : spmd_Index.C
 * Author       : Guansong Zhang
 * Created      : Thu Jan  8 10:05:03 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/09/29 19:48:10 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "spmd_Index.h"

#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;
#include "jctable.h"

extern jctable<Location> spmd_Location_Table;

Location * spmd_Location_ResolvePtr(JNIEnv *, jobject);
Range * spmd_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
Index * spmd_Index_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((Index *)spmd_Location_ResolvePtr(env, jthis));
}

/*
 * Class:     spmd_Index
 * Method:    constructor
 * Signature: (Lspmd/Range;)V
 */
JNIEXPORT void JNICALL Java_spmd_Index_constructor
  (JNIEnv * env, jobject jthis, jobject jRange)
{
  Index * cppIndex = new Index(*spmd_Range_ResolvePtr(env, jRange));

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (spmd_Location_Table.ObjPtr[pos]);
  
  spmd_Location_Table.ObjPtr[pos]=cppIndex;

  if (spmd_Location_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
  
};

/*
 * Class:     spmd_Index
 * Method:    begin
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Index_begin
  (JNIEnv * env, jobject jthis)
{
  spmd_Index_ResolvePtr(env, jthis)->begin();
};

/*
 * Class:     spmd_Index
 * Method:    next
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Index_next
  (JNIEnv * env, jobject jthis)
{
  spmd_Index_ResolvePtr(env, jthis)->next();
};

/*
 * Class:     spmd_Index
 * Method:    idx
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_spmd_Index_idx
  (JNIEnv * env, jobject jthis)
{
  //  return (int)(*spmd_Index_ResolvePtr(env, jthis));
  return printf("function canceled.\n");
};

/*
 * Class:     spmd_Index
 * Method:    shift
 * Signature: (I)Lspmd/Location;
 */
JNIEXPORT jobject JNICALL Java_spmd_Index_shift
  (JNIEnv * env, jobject jthis, jint amount)
{
  Location location;

  if (amount>=0)
    location = (*spmd_Index_ResolvePtr(env, jthis)>>amount);
  else
    location = (*spmd_Index_ResolvePtr(env, jthis)<<(-amount));
      
  jclass ccLocation=NULL;
  ccLocation=env->FindClass("spmd/Location");
  if (env->ExceptionOccurred()) return 0;
  jmethodID handleConstructorID = env->GetMethodID(ccLocation, "<init>", "()V");
  jobject jNode=env->NewObject(ccLocation, handleConstructorID);

  Location *newLocationPtr=spmd_Location_ResolvePtr(env,jNode);

  *newLocationPtr=location;

  return(jNode);
};
